//+------------------------------------------------------------------+
//|                          Bollinger bands multiple deviations.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      ""

#property indicator_chart_window
#property indicator_buffers 7
#property indicator_color1 DimGray
#property indicator_color2 C'0,128,0'
#property indicator_color3 C'128,0,0'
#property indicator_color4 C'0,192,0'
#property indicator_color5 C'192,0,0'
#property indicator_color6 C'0,255,0'
#property indicator_color7 C'255,0,0'
#property indicator_style1 STYLE_DOT

//
//
//
//
//

extern int    BandsLength     =    20;
extern double BandsDeviation1 = 1.618; 
extern double BandsDeviation2 = 2.618; 
extern double BandsDeviation3 = 3.618; 

//
//
//
//
//

double MaBuffer[];
double UpperBand1[];
double LowerBand1[];
double UpperBand2[];
double LowerBand2[];
double UpperBand3[];
double LowerBand3[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int init()
{
   SetIndexBuffer(0,MaBuffer);
   SetIndexBuffer(1,UpperBand1);
   SetIndexBuffer(2,LowerBand1);
   SetIndexBuffer(3,UpperBand2);
   SetIndexBuffer(4,LowerBand2);
   SetIndexBuffer(5,UpperBand3);
   SetIndexBuffer(6,LowerBand3);

   //
   //
   //
   //
   //

   SetIndexLabel(0,"Bands ma");
   SetIndexLabel(1,"Bands upper band 1");
   SetIndexLabel(2,"Bands lower band 1");
   SetIndexLabel(3,"Bands upper band 2");
   SetIndexLabel(4,"Bands lower band 2");
   SetIndexLabel(5,"Bands upper band 3");
   SetIndexLabel(6,"Bands lower band 3");
   return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+

int start()
{
   double sum,ma;
   int    counted_bars=IndicatorCounted();
   int    limit,i,k;


   if(counted_bars < 0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;
         
   //
   //
   //
   //
   //

   for (i=limit;i>=0;i--)
      {
         ma = iMA(NULL,0,BandsLength,0,MODE_SMA,PRICE_CLOSE,i);
               for (sum = 0.0, k = 0; k < BandsLength; k++)
                    sum += ((Close[k+i]-ma)*(Close[k+i]-ma));

         //
         //
         //
         //
         //
         
         MaBuffer[i] = ma;
         if (BandsDeviation1!=0) {
               UpperBand1[i]  = ma+BandsDeviation1*MathSqrt(sum/BandsLength);
               LowerBand1[i]  = ma-BandsDeviation1*MathSqrt(sum/BandsLength);
            }               
         if (BandsDeviation2!=0) {
               UpperBand2[i]  = ma+BandsDeviation2*MathSqrt(sum/BandsLength);
               LowerBand2[i]  = ma-BandsDeviation2*MathSqrt(sum/BandsLength);
            }               
         if (BandsDeviation3!=0) {
               UpperBand3[i]  = ma+BandsDeviation3*MathSqrt(sum/BandsLength);
               LowerBand3[i]  = ma-BandsDeviation3*MathSqrt(sum/BandsLength);
            }               
      }            
   return(0);
}